SystemOrganization addCategory: #ConfigurationOfMercuryPrototype!

Object subclass: #ConfigurationOfMercuryPrototype
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfMercuryPrototype'!

!ConfigurationOfMercuryPrototype class methodsFor: 'development support' stamp: 'NickPapoulias 1/14/2013 11:36'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMercuryPrototype class methodsFor: 'private' stamp: 'NickPapoulias 1/14/2013 11:36'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMercuryPrototype class methodsFor: 'private' stamp: 'NickPapoulias 1/14/2013 11:36'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMercuryPrototype class methodsFor: 'private' stamp: 'NickPapoulias 1/14/2013 11:36'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMercuryPrototype class methodsFor: 'metacello tool support' stamp: 'NickPapoulias 1/14/2013 11:36'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMercuryPrototype class methodsFor: 'loading' stamp: 'NickPapoulias 1/14/2013 11:36'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfMercuryPrototype class methodsFor: 'loading' stamp: 'NickPapoulias 1/14/2013 11:36'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfMercuryPrototype class methodsFor: 'loading' stamp: 'NickPapoulias 1/14/2013 11:36'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfMercuryPrototype class methodsFor: 'accessing' stamp: 'NickPapoulias 1/14/2013 11:36'!
project

	^self new project! !

!ConfigurationOfMercuryPrototype class methodsFor: 'development support' stamp: 'NickPapoulias 1/14/2013 11:36'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMercuryPrototype methodsFor: 'accessing' stamp: 'NickPapoulias 1/14/2013 11:36'!
baseline01: spec

	<version: '0.1-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/Seamless'.
		spec project: 'Fuel' with: [
			spec className: 'ConfigurationOfFuel';
				loads: #('Fuel' 'FuelMetalevel');
				repository: 'http://ss3.gemstone.com/ss/Fuel'.
		].
		spec package: 'Seamless' with: [spec requires: 'Fuel']
	 ]
! !

!ConfigurationOfMercuryPrototype methodsFor: 'accessing' stamp: 'NickPapoulias 1/28/2013 20:28'!
baseline02: spec

	<version: '0.2-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/Mercury-Prototype' username: 'nickp' password: 'drift145'.
		spec project: 'Fuel' with: [
			spec 
				className: 'ConfigurationOfFuel';
				loads: #('Fuel' 'FuelMetalevel');
				repository: 'http://ss3.gemstone.com/ss/Fuel'.
		].
		spec package: 'Fuel-Clusters'.
		spec package: 'Seamless'.
		spec package: 'System-Tools'.
		spec package: 'Polymorph-Widgets'.
		spec package: 'Kernel'.
		spec package: 'Mercury-Prototype'.
	 ]
! !

!ConfigurationOfMercuryPrototype methodsFor: 'accessing' stamp: 'NickPapoulias 1/31/2013 13:10'!
baseline03: spec

	<version: '0.3-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/Mercury-Prototype' username: 'nickp' password: 'drift145'.
		spec project: 'Fuel' with: [
			spec 
				className: 'ConfigurationOfFuel';
				loads: #('Fuel' 'FuelMetalevel');
				repository: 'http://ss3.gemstone.com/ss/Fuel'.
		].
		spec package: 'Fuel-Clusters'.
		spec package: 'Seamless'.
		spec package: 'System-Tools'.
		spec package: 'Polymorph-Widgets'.
		spec package: 'Kernel'.
		spec package: 'Mercury-Prototype'.
	 ]
! !

!ConfigurationOfMercuryPrototype methodsFor: 'accessing' stamp: 'NickPapoulias 8/10/2013 16:35'!
baselineDev: spec

	<version: 'dev-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/Mercury-Prototype' username: 'nickp' password: 'drift145'.
		spec project: 'Fuel' with: [
			spec 
				className: 'ConfigurationOfFuel';
				loads: #('Fuel' 'FuelMetalevel');
				repository: 'http://smalltalkhub.com/mc/Pharo/Fuel/main'.
		].
		spec package: 'Fuel-Clusters'.
		spec package: 'Seamless'.
		spec package: 'System-Tools'.
		spec package: 'Polymorph-Widgets'.
		spec package: 'Kernel'.
		spec package: 'Mercury-Prototype'.
		spec package: 'Mercury-Ide'.
		spec package: 'MetaInterpreter'.
	 ]
! !

!ConfigurationOfMercuryPrototype methodsFor: 'accessing' stamp: 'NickPapoulias 1/14/2013 11:36'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfMercuryPrototype methodsFor: 'accessing' stamp: 'NickPapoulias 1/14/2013 11:36'!
version01: spec

	<version: '0.1' imports: #('0.1-baseline')>
	
	spec for: #common do: [
		spec project: 'Fuel' with: #bleedingEdge.
		spec package: 'Seamless' with: 'Seamless-NickPapoulias.258'.
	 ]
! !

!ConfigurationOfMercuryPrototype methodsFor: 'accessing' stamp: 'NickPapoulias 1/29/2013 20:55'!
version02: spec

	<version: '0.2' imports: #('0.2-baseline')>
	
	spec for: #common do: [
		spec project: 'Fuel' with: #bleedingEdge.
		spec package: 'Fuel-Clusters' with: 'Fuel-Clusters-NickPapoulias.1'.
		spec package: 'Seamless' with: 'Seamless-NickPapoulias.266'.
		spec package: 'Kernel' with: 'Kernel-NickPapoulias.1051'.
		spec package: 'Polymorph-Widgets' with: 'Polymorph-Widgets-NickPapoulias.622'.
		spec package: 'System-Tools' with: 'System-Tools-NickPapoulias.83'.
		spec package: 'Mercury-Prototype' with: 'Mercury-Prototype-NickPapoulias.35'.
	 ]
! !

!ConfigurationOfMercuryPrototype methodsFor: 'accessing' stamp: 'NickPapoulias 1/31/2013 13:10'!
version03: spec

	<version: '0.3' imports: #('0.3-baseline')>
	
	spec for: #common do: [
		spec project: 'Fuel' with: #bleedingEdge.
		spec package: 'Fuel-Clusters' with: 'Fuel-Clusters-NickPapoulias.1'.
		spec package: 'Seamless' with: 'Seamless-NickPapoulias.266'.
		spec package: 'Kernel' with: 'Kernel-NickPapoulias.1051'.
		spec package: 'Polymorph-Widgets' with: 'Polymorph-Widgets-NickPapoulias.622'.
		spec package: 'System-Tools' with: 'System-Tools-NickPapoulias.83'.
		spec package: 'Mercury-Prototype' with: 'Mercury-Prototype-NickPapoulias.36'.
	 ]
! !

!ConfigurationOfMercuryPrototype methodsFor: 'accessing' stamp: 'NickPapoulias 8/2/2013 12:47'!
versionDev: spec

	<version: 'dev' imports: #('dev-baseline')>
	
	spec for: #common do: [
		spec project: 'Fuel' with: #bleedingEdge.
		spec package: 'Fuel-Clusters' with: 'Fuel-Clusters-NickPapoulias.1'.
		spec package: 'Seamless' with: 'Seamless-NickPapoulias.266'.
		spec package: 'Kernel' with: 'Kernel-NickPapoulias.1053'.
		spec package: 'Polymorph-Widgets' with: 'Polymorph-Widgets-NickPapoulias.622'.
		spec package: 'System-Tools' with: 'System-Tools-NickPapoulias.89'.
		spec package: 'Mercury-Prototype' with: 'Mercury-Prototype-NickPapoulias.94'.
		spec package: 'Mercury-Prototype-DebuggingSeed' with: 'Mercury-Prototype-DebuggingSeed-NickPapoulias.17'.
		spec package: 'Mercury-Prototype-RunTimeDebuggingSupport' with: 'Mercury-Prototype-RunTimeDebuggingSupport-NickPapoulias.54'.
		spec package: 'Mercury-Ide' with: 'Mercury-Ide-NickPapoulias.96'.
		spec package: 'MetaInterpreter' with: 'MetaInterpreter-NickPapoulias.129'.
	 ]
! !

Object subclass: #ConfigurationOfMercuryPrototypeTarget
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfMercuryPrototype'!

!ConfigurationOfMercuryPrototypeTarget class methodsFor: 'development support' stamp: 'NickPapoulias 1/29/2013 09:51'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMercuryPrototypeTarget class methodsFor: 'private' stamp: 'NickPapoulias 1/29/2013 09:51'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMercuryPrototypeTarget class methodsFor: 'private' stamp: 'NickPapoulias 1/29/2013 09:51'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMercuryPrototypeTarget class methodsFor: 'private' stamp: 'NickPapoulias 1/29/2013 09:51'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMercuryPrototypeTarget class methodsFor: 'metacello tool support' stamp: 'NickPapoulias 1/29/2013 09:51'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMercuryPrototypeTarget class methodsFor: 'loading' stamp: 'NickPapoulias 1/29/2013 09:51'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfMercuryPrototypeTarget class methodsFor: 'loading' stamp: 'NickPapoulias 1/29/2013 09:51'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfMercuryPrototypeTarget class methodsFor: 'loading' stamp: 'NickPapoulias 1/29/2013 09:51'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfMercuryPrototypeTarget class methodsFor: 'accessing' stamp: 'NickPapoulias 1/29/2013 09:51'!
project

	^self new project! !

!ConfigurationOfMercuryPrototypeTarget class methodsFor: 'development support' stamp: 'NickPapoulias 1/29/2013 09:51'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMercuryPrototypeTarget methodsFor: 'accessing' stamp: 'NickPapoulias 1/29/2013 09:51'!
baseline01: spec

	<version: '0.1-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/Seamless'.
		spec project: 'Fuel' with: [
			spec className: 'ConfigurationOfFuel';
				loads: #('Fuel' 'FuelMetalevel');
				repository: 'http://ss3.gemstone.com/ss/Fuel'.
		].
		spec package: 'Seamless' with: [spec requires: 'Fuel']
	 ]
! !

!ConfigurationOfMercuryPrototypeTarget methodsFor: 'accessing' stamp: 'NickPapoulias 1/29/2013 09:54'!
baseline02: spec

	<version: '0.2-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/Mercury-Prototype' username: 'nickp' password: 'drift145'.
		spec project: 'Fuel' with: [
			spec 
				className: 'ConfigurationOfFuel';
				loads: #('Fuel' 'FuelMetalevel');
				repository: 'http://ss3.gemstone.com/ss/Fuel'.
		].
		spec package: 'Fuel-Clusters'.
		spec package: 'Seamless'.
		spec package: 'System-Tools'.
		spec package: 'Polymorph-Widgets'.
		spec package: 'Kernel'.
		spec package: 'Mercury-Prototype-DebuggingSeed'.
		spec package: 'Mercury-Prototype-RunTimeDebuggingSupport'.
	 ]
! !

!ConfigurationOfMercuryPrototypeTarget methodsFor: 'accessing' stamp: 'NickPapoulias 1/31/2013 13:11'!
baseline03: spec

	<version: '0.3-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/Mercury-Prototype' username: 'nickp' password: 'drift145'.
		spec project: 'Fuel' with: [
			spec 
				className: 'ConfigurationOfFuel';
				loads: #('Fuel' 'FuelMetalevel');
				repository: 'http://ss3.gemstone.com/ss/Fuel'.
		].
		spec package: 'Fuel-Clusters'.
		spec package: 'Seamless'.
		spec package: 'System-Tools'.
		spec package: 'Polymorph-Widgets'.
		spec package: 'Kernel'.
		spec package: 'Mercury-Prototype-DebuggingSeed'.
		spec package: 'Mercury-Prototype-RunTimeDebuggingSupport'.
	 ]
! !

!ConfigurationOfMercuryPrototypeTarget methodsFor: 'accessing' stamp: 'NickPapoulias 8/10/2013 16:35'!
baselineDev: spec

	<version: 'dev-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/Mercury-Prototype' username: 'nickp' password: 'drift145'.
		spec project: 'Fuel' with: [
			spec 
				className: 'ConfigurationOfFuel';
				loads: #('Fuel' 'FuelMetalevel');
				repository: 'http://smalltalkhub.com/mc/Pharo/Fuel/main'.
		].
		spec package: 'Fuel-Clusters'.
		spec package: 'Seamless'.
		spec package: 'System-Tools'.
		spec package: 'Polymorph-Widgets'.
		spec package: 'Kernel'.
		spec package: 'Mercury-Prototype-DebuggingSeed'.
		spec package: 'Mercury-Prototype-RunTimeDebuggingSupport'.
		spec package: 'MetaInterpreter'.
	 ]
! !

!ConfigurationOfMercuryPrototypeTarget methodsFor: 'accessing' stamp: 'NickPapoulias 1/29/2013 09:51'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfMercuryPrototypeTarget methodsFor: 'accessing' stamp: 'NickPapoulias 1/29/2013 09:51'!
version01: spec

	<version: '0.1' imports: #('0.1-baseline')>
	
	spec for: #common do: [
		spec project: 'Fuel' with: #bleedingEdge.
		spec package: 'Seamless' with: 'Seamless-NickPapoulias.258'.
	 ]
! !

!ConfigurationOfMercuryPrototypeTarget methodsFor: 'accessing' stamp: 'NickPapoulias 1/29/2013 20:46'!
version02: spec

	<version: '0.2' imports: #('0.2-baseline')>
	
	spec for: #common do: [
		spec project: 'Fuel' with: #bleedingEdge.
		spec package: 'Fuel-Clusters' with: 'Fuel-Clusters-NickPapoulias.1'.
		spec package: 'Seamless' with: 'Seamless-NickPapoulias.267'. "target port"
		spec package: 'Kernel' with: 'Kernel-NickPapoulias.1051'.
		spec package: 'Polymorph-Widgets' with: 'Polymorph-Widgets-NickPapoulias.622'.
		spec package: 'System-Tools' with: 'System-Tools-NickPapoulias.83'.
		spec package: 'Mercury-Prototype-DebuggingSeed' with: 'Mercury-Prototype-DebuggingSeed-NickPapoulias.10'.
		spec package: 'Mercury-Prototype-RunTimeDebuggingSupport' with: 'Mercury-Prototype-RunTimeDebuggingSupport-NickPapoulias.13'.
	 ]
! !

!ConfigurationOfMercuryPrototypeTarget methodsFor: 'accessing' stamp: 'NickPapoulias 1/31/2013 13:11'!
version03: spec

	<version: '0.3' imports: #('0.3-baseline')>
	
	spec for: #common do: [
		spec project: 'Fuel' with: #bleedingEdge.
		spec package: 'Fuel-Clusters' with: 'Fuel-Clusters-NickPapoulias.1'.
		spec package: 'Seamless' with: 'Seamless-NickPapoulias.267'. "target port"
		spec package: 'Kernel' with: 'Kernel-NickPapoulias.1051'.
		spec package: 'Polymorph-Widgets' with: 'Polymorph-Widgets-NickPapoulias.622'.
		spec package: 'System-Tools' with: 'System-Tools-NickPapoulias.83'.
		spec package: 'Mercury-Prototype-DebuggingSeed' with: 'Mercury-Prototype-DebuggingSeed-NickPapoulias.11'.
		spec package: 'Mercury-Prototype-RunTimeDebuggingSupport' with: 'Mercury-Prototype-RunTimeDebuggingSupport-NickPapoulias.14'.
	 ]
! !

!ConfigurationOfMercuryPrototypeTarget methodsFor: 'accessing' stamp: 'NickPapoulias 8/2/2013 12:47'!
versionDev: spec

	<version: 'dev' imports: #('dev-baseline')>
	
	spec for: #common do: [
		spec project: 'Fuel' with: #bleedingEdge.
		spec package: 'Fuel-Clusters' with: 'Fuel-Clusters-NickPapoulias.1'.
		spec package: 'Seamless' with: 'Seamless-NickPapoulias.267'. "target port"
		spec package: 'Kernel' with: 'Kernel-NickPapoulias.1053'.
		spec package: 'Polymorph-Widgets' with: 'Polymorph-Widgets-NickPapoulias.622'.
		spec package: 'System-Tools' with: 'System-Tools-NickPapoulias.89'.
		spec package: 'Mercury-Prototype-DebuggingSeed' with: 'Mercury-Prototype-DebuggingSeed-NickPapoulias.17'.
		spec package: 'Mercury-Prototype-RunTimeDebuggingSupport' with: 'Mercury-Prototype-RunTimeDebuggingSupport-NickPapoulias.54'.
		spec package: 'MetaInterpreter' with: 'MetaInterpreter-NickPapoulias.129'.
	 ]
! !
